## boxbackup 0.11~rc3~r2502

=== docs/Makefile ===


# Process DocBook to HTML

DBPROC=xsltproc

DOCBOOK_DIR = docbook
HTML_DIR = htmlguide
MAN_DIR = man

BOOKXSL = $(DOCBOOK_DIR)/bb-book.xsl
NOCHUNKBOOKXSL = $(DOCBOOK_DIR)/bb-nochunk-book.xsl
MANXSL = $(DOCBOOK_DIR)/bb-man.xsl

VPATH = $(DOCBOOK_DIR)
.SUFFIXES: .html .xml .gz .1 .5 .8

all: docs

docs: instguide adminguide manpages
	@mkdir -p $(HTML_DIR)/images
	@cp $(DOCBOOK_DIR)/html/images/*.png $(HTML_DIR)/images/.
	@cp $(DOCBOOK_DIR)/html/*.css $(HTML_DIR)/.
	@cp $(DOCBOOK_DIR)/html/*.ico $(HTML_DIR)/.

adminguide: $(DOCBOOK_DIR)/ExceptionCodes.xml $(HTML_DIR)/adminguide/index.html 

# all sources ($>) is exactly the right args for xsltproc
$(HTML_DIR)/adminguide/index.html: $(BOOKXSL) $(DOCBOOK_DIR)/adminguide.xml
	$(DBPROC) -o $(HTML_DIR)/adminguide/ $>

instguide: $(HTML_DIR)/instguide/index.html 

$(HTML_DIR)/instguide/index.html: $(BOOKXSL) $(DOCBOOK_DIR)/instguide.xml
	$(DBPROC) -o $(HTML_DIR)/instguide/ $>

# $< is empty on BSD make when making this rule, $> has all sources
# $< has the target on GNU make, $> is empty
$(DOCBOOK_DIR)/ExceptionCodes.xml: ../ExceptionCodes.txt
	perl tools/generate_except_xml.pl $< $> $@

manpages: man-dirs man-nroff man-html

xslt: $(MANXSL)

$(MANXSL): $(MANXSL).tmpl
	@if [ -f /usr/local/share/xsl/docbook/manpages/docbook.xsl ]; then \
	   DOCBOOK=file:///usr/local/share/xsl/docbook/manpages/docbook.xsl; \
	 elif [ -f /opt/local/share/xsl/docbook-xsl/manpages/docbook.xsl ]; then \
	   DOCBOOK=file:///opt/local/share/xsl/docbook-xsl/manpages/docbook.xsl; \
	 elif [ -f /usr/share/sgml/docbook/xsl-stylesheets/manpages/docbook.xsl ]; then \
	   DOCBOOK=file:///usr/share/sgml/docbook/xsl-stylesheets/manpages/docbook.xsl; \
	 else \
	   DOCBOOK=http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl; \
	 fi; \
	 sed -e "s,%%DOCBOOK%%,$${DOCBOOK}," $(MANXSL).tmpl > $(MANXSL)

man-dirs: man/.there $(HTML_DIR)/man-html/.there

$(HTML_DIR)/man-html/.there:
	mkdir -p $(HTML_DIR)/man-html
	touch $(HTML_DIR)/man-html/.there

man/.there:
	mkdir -p man
	touch man/.there

NROFF_PAGES = bbackupd.8 bbackupd-config.8 bbackupctl.8 bbackupquery.8 \
	bbstored.8 bbstored-config.8 bbstoreaccounts.8 bbstored-certs.8 \
	raidfile-config.8 \
	bbackupd.conf.5 bbstored.conf.5 raidfile.conf.5

NROFF_FILES = $(NROFF_PAGES:%=$(MAN_DIR)/%.gz)

man-nroff: $(NROFF_FILES)

HTML_FILES_1 = $(NROFF_PAGES:%.5=%.html)
HTML_FILES_2 = $(HTML_FILES_1:%.8=%.html)
HTML_FILES   = $(HTML_FILES_2:%=$(HTML_DIR)/man-html/%)

man-html: $(HTML_FILES)

# GNU make
$(HTML_DIR)/man-html/%.html: $(DOCBOOK_DIR)/%.xml $(NOCHUNKBOOKXSL)
	$(DBPROC) -o $@ $(NOCHUNKBOOKXSL) $<

# Before running xsltproc to generate manual pages, we need to check
# that $(MANXSL) has been built. We don't want to add it to dependencies,
# because that would cause # the man pages to try to be rebuilt even if
# they already exist if the date of the xslt file changes, and that
# requires xsltproc, which negates the point of precompiling them for
# distribution users.

# GNU make
$(MAN_DIR)/%.8.gz: $(DOCBOOK_DIR)/%.xml
	$(MAKE) xslt
	$(DBPROC) -o $(@:.gz=) $(MANXSL) $<
	gzip $(@:.gz=)

# GNU make
$(MAN_DIR)/%.5.gz: $(DOCBOOK_DIR)/%.xml
	$(MAKE) xslt
	$(DBPROC) -o $(@:.gz=) $(MANXSL) $<
	gzip $(@:.gz=)

# BSD make: the final colon (:) is required to make the .for and .endfor
# lines valid in GNU make. It creates (different) dummy rules in GNU and
# BSD make. Both dummy rules are harmless.

.for MAN_PAGE in $(NROFF_PAGES) :
$(MAN_DIR)/$(MAN_PAGE).gz: $(DOCBOOK_DIR)/$(MAN_PAGE:R).xml
	$(MAKE) xslt
	$(DBPROC) -o $(.TARGET:.gz=) $(MANXSL) $>
	gzip $(@:.gz=)

$(HTML_DIR)/man-html/$(MAN_PAGE:R).html: $(DOCBOOK_DIR)/$(MAN_PAGE:R).xml
	$(DBPROC) -o $@ $(NOCHUNKBOOKXSL) $>
.endfor :

dockit: clean docs
	tar zcf documentation-kit-0.10.tar.gz $(HTML_DIR)/

clean:
	rm -f $(HTML_FILES)
	rm -f $(NROFF_FILES)
	rm -f $(DOCBOOK_DIR)/ExceptionCodes.xml
	rm -f documentation-kit-0.10.tar.gz
	rm -f $(MANXSL)

## boxbackup 0.11.1~r2837

=== debian/changelog ===
boxbackup (0.11.1~r2837-4) unstable; urgency=medium

  * QA upload.
  * Check for ucf and deluser availability before calling them during postrm
    purge.  (Closes: #688373, #667535)
  * Add Italian (it) debconf translations by Beatrice Torracca.
    (Closes: #658724)
  * Add Dutch (nl) debconf translations by Frans Spiesschaert.
    (Closes: #766532)
  * Build with dh_autotools-dev_*.
  * Switch to source format 3.0 (quilt).

 -- Andreas Beckmann <anbe@debian.org>  Sun, 22 Jan 2017 03:29:52 +0100

boxbackup (0.11.1~r2837-3) unstable; urgency=medium

  * QA upload.
  * Build with openssl 1.0. Thanks to Adrian Bunk. (Closes: #828253)
  * Bump Standards-Version to 3.9.8.

 -- Chris Lamb <lamby@debian.org>  Sat, 12 Nov 2016 14:15:06 +0000

boxbackup (0.11.1~r2837-2) unstable; urgency=medium

  * Ensure that LWP/UserAgent.pm is available (Closes: #816517)
  * Orphaning package, cf. #817078

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 07 Mar 2016 20:19:45 -0500

boxbackup (0.11.1~r2837-1) unstable; urgency=low

  * New upstream release.
    -  Bug fix: "Handling of "get" command broken due to bug in
       temp file name creation.", thanks to Matto Marjanovic
       (Closes: #606559).
  * Bug fix: "[INTL:pt_BR] Brazilian Portuguese debconf templates
    translation", thanks to Adriano Rafael Gomes (Closes: #610416).
  * Bug fix: "[INTL:da] Fix Danish translation of the debconf templates
    BoxBackup", thanks to Joe Dalton (Closes: #619303).
  * Bug fix: "Documentation errors regarding bbstored-certs", thanks to
    Clint Adams (Closes: #601882).
  * Build in verbose mode.
  * Bump standards version to 3.9.2, no changes needed.
  * Normalize fields in debian/control with wrap-and-sort(1).
  * implement build-arch and build-indep targets

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 28 Oct 2011 01:53:48 +0200

boxbackup (0.11~rc8~r2714-1) unstable; urgency=low

  * New upstream release.
  * New Upstream fixes Bug: "boxbackup-client complains about
    /home/*/.gvfs", thanks for reporting to Sune Mølgaard.
    Closes: #593401, LP: #496334
  * Enhancement: "Please use newer bdb", thanks to Clint Adams 
    Closes: #548475
  * bin/bbstored/bbstored-certs: reduce root CA expiration date to avoid
    Y2k38 overflow. Thanks to Clint Adams <schizo@debian.org> for
    reporting it. Closes: #601506, LP: #641112
  * By default, do not manage boxbackup-client configuration via debconf
  * Allow dpkg-reconfigure to work even when the debconf level is set to
    'high'.
  * Various debconf severity fixes in boxbackup-*.conf

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 09 Nov 2010 18:14:58 +0100

boxbackup (0.11~rc3~r2502-4) unstable; urgency=low

  * use more globs in install paths to avoid failures on kFreeBSD
  * Bump standards version, no changes needed

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 13 Oct 2010 20:51:39 +0200

boxbackup (0.11~rc3~r2502-3) unstable; urgency=low

  * Update Vitnamese debconf translations. Closes: #598581

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 12 Oct 2010 10:50:37 +0200

boxbackup (0.11~rc3~r2502-2.1ubuntu1) maverick; urgency=low

  * fix install paths for armel (LP: #616461) 

 -- David Sugar <david.sugar@canonical.com>  Mon, 16 Aug 2010 23:49:22 +0200

boxbackup (0.11~rc3~r2502-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * No longer hardcode path to tune2fs in config script
  * Fix pending l10n issues. Debconf translations:
    - Spanish (Omar Campagne).  Closes: #537589
    - Japanese (Hideki Yamane (Debian-JP)).  Closes: #558074
    - Danish (Joe Hansen).  Closes: #582174

 -- Christian Perrier <bubulle@debian.org>  Mon, 24 May 2010 09:33:23 +0200

boxbackup (0.11~rc3~r2502-2) unstable; urgency=low

  * Bug fix: "tries to contact a server build-time", thanks to
    Riku Voipio for reporting. Fix based on a patch contributed
    by peter green, thanks as well! (Closes: #525277).
  * Bug fix: "missing #include", thanks to Martin Michlmayr 
    (Closes: #526152, LP: #371809)
  
 -- Reinhard Tartler <siretart@tauware.de>  Tue, 05 May 2009 07:42:40 +0200

boxbackup (0.11~rc3~r2502-1) unstable; urgency=low

  * New upstream release, built from svn revision 2502.
    - silently ignores sockets and named pipes (Closes: #479145)
    - syslog facility is now configurable (Closes: #521283)

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 02 Apr 2009 13:58:17 +0200

boxbackup (0.11~rc2+r2072-1) unstable; urgency=low

  * New upstream release. (Closes: #503942)
  * no longer use the upstream tarballs, but create them with the script
    debian/get-orig-source.sh to create the orig.tar.gz. See README.Debian
    for a rationale of this step.
  * Therefore, run autoconf on the buildds.
  * always use config.sub/config.guess from the autotools-dev package
  * Fake a "VERSION.txt" instead of letting the build system try to figure
    out the svn version by itself (which would fail)
  * no longer include patches to the upstream source inline. This doesn't
    work out too well with bzr. Port all patches to quilt instead.
  * factor out distribution independent cleaning rules to a new shell script
    called debian/clean.sh.
  * make debian/NEWS actually parsable by dpkg-parsechangelog. This should
    make apt-parsechangelog work.
  * Update debian specific documentation to new URL: http://boxbackup.org
  * Don't install the files DOCUMENTATION.txt and CONTACT.txt. Both contain
    just (outdated) contact addresses and URLs. (Closes: #503659)
  * add translation for swedish debconf messages. Translation provided by
    Martin Bagge <brother@bsnet.se>. (Closes: #513776)
  * adjust configure.ac to only AC_SUBST single variables instead of 3 in
    a row. Fixes FTBFS on sid, found at http://bugs.gentoo.org/205558

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 31 Mar 2009 15:58:23 +0200

boxbackup (0.11~rc2-6) unstable; urgency=low

  * Fix shell scripting in the debconf interaction code of the package's


=== debian/control ===
Source: boxbackup
Section: utils
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 autoconf,
 automake,
 autotools-dev,
 debhelper (>> 7.0.0),
 docbook-utils,
 docbook-xml,
 docbook-xsl,
 libdb-dev (>= 4.7),
 libedit-dev,
 libssl1.0-dev,
 libtest-lwp-useragent-perl,
 xsltproc,
 zlib1g-dev
Standards-Version: 3.9.8
Homepage: http://boxbackup.org
Vcs-Git: git://anonscm.debian.org/collab-maint/boxbackup.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/boxbackup.git

Package: boxbackup-server
Architecture: any
Depends:
 adduser,
 debconf | debconf-2.0,
 gawk,
 openssl,
 perl,
 ucf,
 ${misc:Depends},
 ${shlibs:Depends}
Description: server for the BoxBackup remote backup system
 BoxBackup is an automatic on-line backup system.
 The server waits for connections from remote clients,
 authenticates them via X.509 certificates and stores the
 encrypted data on hard drives with optional RAID techniques.
 It also supports versions historization and per-user quotas.

Package: boxbackup-client
Architecture: any
Depends:
 debconf | debconf-2.0,
 openssl,
 perl,
 ucf,
 ${misc:Depends},
 ${shlibs:Depends}
Description: client for the BoxBackup remote backup system
 BoxBackup is an automatic on-line backup system.
 The client watches for changes on the local file system,
 connects to a BoxBackup server and sends the changes via a
 secure channel. All data is encrypted before being sent to
 the server. A command-line tool is provided for restoration
 of backups including deleted files and old versions.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

TMP:=$(CURDIR)/debian/tmp

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	dh_autotools-dev_updateconfig
	echo "0.11rc8+`cat .svnrevision`" > VERSION.txt
	echo "boxbackup" >> VERSION.txt
	sh -x ./bootstrap
	./configure $(DEB_EXTRA_CONFIG_FLAGS) LDFLAGS="-Wl,--as-needed"
	touch configure-stamp

build-stamp: configure-stamp
	dh_testdir
	$(MAKE) V=1
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	-./runtest.pl ALL
endif
	touch build-stamp

docs/docbook/instguide.pdf:
	$(MAKE) -C docs instguide
	cd docs/docbook && docbook2pdf instguide.xml

docs/docbook/adminguide.pdf: configure-stamp
	$(MAKE) -C docs adminguide
	cd docs/docbook && docbook2pdf adminguide.xml

docs: docs/docbook/instguide.pdf docs/docbook/adminguide.pdf
	$(MAKE) -C docs manpages

build-arch: build-stamp
build-indep: docs

build: build-arch build-indep

clean:
	dh_testdir
	dh_testroot
	dh_clean build-stamp configure-stamp
	echo "USE_SVN_VERSION" > VERSION.txt
	echo "boxbackup" >> VERSION.txt
	[ ! -f Makefile ] || make clean
	sh debian/clean.sh
	dh_autotools-dev_restoreconfig
	dh_clean config.log config.status 

install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	mkdir -p $(TMP)/etc/logcheck/ignore.d.workstation
	mkdir -p $(TMP)/etc/logcheck/ignore.d.server
	install -m 644 debian/boxbackup-server.logcheck.ignore $(TMP)/etc/logcheck/ignore.d.workstation/boxbackup-server
	install -m 644 debian/boxbackup-server.logcheck.ignore $(TMP)/etc/logcheck/ignore.d.server/boxbackup-server

	dh_install

binary-indep:
#  no architecture independant packages are being built

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installdebconf -a
	dh_installdocs -a -A ExceptionCodes.txt docs/docbook/instguide.pdf docs/docbook/adminguide.pdf
	dh_installinit -a
	dh_installcron -a
	dh_installman
	dh_installchangelogs  -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-arch
.PHONY: build build-arch build-indep clean binary-indep binary-arch binary install docs

=== debian/watch ===
version=3
# release candidates are not on sf
# http://sf.net/boxbackup/ boxbackup-(.*)\.tgz
http://boxbackup.org/svn/box/packages/ boxbackup-(.*)\.tgz

## boxbackup 0.13~~git20180313.g16a11e86

=== infrastructure/cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
	# Support Unix Makefiles and Ninja
	set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
endif()

project(BoxBackup)
enable_testing()

set(base_dir ${CMAKE_SOURCE_DIR}/../..)

set(files_to_configure
	bin/bbackupd/bbackupd-config
	bin/bbstored/bbstored-certs
	bin/bbstored/bbstored-config
	contrib/mac_osx/org.boxbackup.bbackupd.plist
	contrib/mac_osx/org.boxbackup.bbstored.plist
	contrib/solaris/bbackupd-manifest.xml
	contrib/solaris/bbstored-manifest.xml
	contrib/debian/bbackupd
	contrib/debian/bbstored
	contrib/redhat/bbackupd
	contrib/redhat/bbstored
	contrib/suse/bbackupd
	contrib/suse/bbstored
	contrib/solaris/bbackupd-smf-method
	contrib/solaris/bbstored-smf-method
	contrib/windows/installer/boxbackup.mpi
	infrastructure/BoxPlatform.pm
	infrastructure/makebuildenv.pl
	infrastructure/makedistribution.pl
	lib/bbackupquery/makedocumentation.pl
	lib/common/BoxPortsAndFiles.h
	lib/common/makeexception.pl
	lib/raidfile/raidfile-config
	lib/server/makeprotocol.pl
	runtest.pl
	test/backupstorefix/testfiles/testbackupstorefix.pl
	test/bbackupd/testfiles/bbackupd.conf
	test/bbackupd/testfiles/bbackupd-exclude.conf
	test/bbackupd/testfiles/bbackupd-snapshot.conf
	test/bbackupd/testfiles/bbackupd-symlink.conf
	test/bbackupd/testfiles/bbackupd-temploc.conf
	test/bbackupd/testfiles/extcheck1.pl
	test/bbackupd/testfiles/extcheck2.pl
	test/bbackupd/testfiles/notifyscript.pl
	test/bbackupd/testfiles/syncallowscript.pl
)

# We need to substitute TARGET_PERL in test/bbackupd/testfiles/bbackupd.conf, so define it
# as a variable before running configure_file().
include(FindPerl)
set(TARGET_PERL ${PERL_EXECUTABLE})

function(replace_file_if_different dest_file source_file)
	execute_process(
		COMMAND "${CMAKE_COMMAND}" -E
		copy_if_different "${source_file}" "${dest_file}")
	execute_process(
		COMMAND "${CMAKE_COMMAND}" -E
		remove "${source_file}")
endfunction()

function(move_file_if_exists source_file dest_file)
	if(EXISTS "${source_file}")
		execute_process(
			COMMAND "${CMAKE_COMMAND}" -E
			rename "${source_file}" "${dest_file}")
	endif()
endfunction()

foreach(file_to_configure ${files_to_configure})
	configure_file("${base_dir}/${file_to_configure}.in" "${base_dir}/${file_to_configure}.out" @ONLY)
	replace_file_if_different(
		"${base_dir}/${file_to_configure}"
		"${base_dir}/${file_to_configure}.out")
endforeach()

# If BOXBACKUP_VERSION is defined when running CMake (as the AppVeyor config does), use it
# as-is, since it contains the full version number, branch, and platform (Win32/Win64):
if(BOXBACKUP_VERSION)
	set(boxbackup_version ${BOXBACKUP_VERSION})
	# Remove CPACK_SYSTEM_NAME from the default CPACK_PACKAGE_NAME, because it's already
	# included in the CPACK_PACKAGE_VERSION:
	set(CPACK_PACKAGE_FILE_NAME ${CMAKE_PROJECT_NAME}-${boxbackup_version})
else()
	# Work out the current Box version (requires Perl) and update lib/common/BoxVersion.h,
	# but only if it has changed, to avoid unnecessary complete rebuilds due to timestamps.
	execute_process(
		COMMAND ${PERL_EXECUTABLE} ${base_dir}/infrastructure/cmake/getversion.pl
		WORKING_DIRECTORY ${base_dir}/infrastructure
		RESULT_VARIABLE status
		OUTPUT_VARIABLE boxbackup_version
		OUTPUT_STRIP_TRAILING_WHITESPACE
		ERROR_VARIABLE command_output)
	if(NOT status EQUAL 0)
		message(FATAL_ERROR "Failed to execute: "
			"${PERL_EXECUTABLE} ${base_dir}/infrastructure/cmake/getversion.pl: "
			"status ${status}: ${command_output}")
	endif()
endif()

file(WRITE "${base_dir}/lib/common/BoxVersion.h.new"
	"#define BOX_VERSION \"${boxbackup_version}\"\n")
replace_file_if_different(
	"${base_dir}/lib/common/BoxVersion.h"
	"${base_dir}/lib/common/BoxVersion.h.new")

add_definitions(-DBOX_CMAKE -DNEED_BOX_VERSION_H)

if(WIN32)
	add_definitions(-DWIN32)
endif()

# Parsing Makefile.extra files in CMake script is a pain, so the relevant rules for
# code-generating Perl scripts are hard-coded here.

set(exception_files
	lib/backupclient/ClientException.txt
	lib/backupstore/BackupStoreException.txt
	lib/common/CommonException.txt
	lib/common/ConversionException.txt
	lib/compress/CompressException.txt
	lib/crypto/CipherException.txt
	lib/httpserver/HTTPException.txt
	lib/raidfile/RaidFileException.txt
	lib/server/ServerException.txt
	lib/server/ConnectionException.txt
)

foreach(exception_file ${exception_files})
	string(REGEX MATCH "(.*)/(.*).txt" valid_exception_file ${exception_file})
	if(NOT valid_exception_file)
		message(FATAL_ERROR "invalid exception file: '${exception_file}'")
	endif()

	set(output_file "${base_dir}/${CMAKE_MATCH_1}/autogen_${CMAKE_MATCH_2}.cpp")
	add_custom_command(OUTPUT "${output_file}"
		MAIN_DEPENDENCY "${base_dir}/${exception_file}"
		COMMAND ${PERL_EXECUTABLE} "${base_dir}/lib/common/makeexception.pl" "${CMAKE_MATCH_2}.txt"
		WORKING_DIRECTORY "${base_dir}/${CMAKE_MATCH_1}")

	string(REPLACE "/" "_" module_name ${CMAKE_MATCH_1})
	set(${module_name}_extra_files ${${module_name}_extra_files} ${output_file})
endforeach()

set(protocol_files
	lib/backupstore/BackupProtocol.txt
	test/basicserver/TestProtocol.txt
)

foreach(protocol_file ${protocol_files})
	string(REGEX MATCH "(.*)/(.*).txt" valid_protocol_file ${protocol_file})
	if(NOT valid_protocol_file)
		message(FATAL_ERROR "invalid protocol file: '${protocol_file}'")
	endif()

	set(output_file "${base_dir}/${CMAKE_MATCH_1}/autogen_${CMAKE_MATCH_2}.cpp")
	add_custom_command(OUTPUT "${output_file}"
		MAIN_DEPENDENCY "${base_dir}/${protocol_file}"
		COMMAND ${PERL_EXECUTABLE} "${base_dir}/lib/server/makeprotocol.pl" "${CMAKE_MATCH_2}.txt"
		WORKING_DIRECTORY "${base_dir}/${CMAKE_MATCH_1}")

	string(REPLACE "/" "_" module_name ${CMAKE_MATCH_1})
	set(${module_name}_extra_files ${${module_name}_extra_files} ${output_file})
endforeach()

set(documentation_files
	lib/bbackupquery/Documentation.txt
)

foreach(documentation_file ${documentation_files})
	string(REGEX MATCH "(.*)/(.*).txt" valid_documentation_file ${documentation_file})
	if(NOT valid_documentation_file)
		message(FATAL_ERROR "invalid documentation file: '${documentation_file}'")
	endif()

	set(output_file "${base_dir}/${CMAKE_MATCH_1}/autogen_${CMAKE_MATCH_2}.cpp")
	add_custom_command(OUTPUT "${output_file}"
		MAIN_DEPENDENCY "${base_dir}/${documentation_file}"
		COMMAND ${PERL_EXECUTABLE} "${base_dir}/lib/bbackupquery/makedocumentation.pl"
		WORKING_DIRECTORY "${base_dir}/${CMAKE_MATCH_1}")

	string(REPLACE "/" "_" module_name ${CMAKE_MATCH_1})
	set(${module_name}_extra_files ${${module_name}_extra_files} ${output_file})
endforeach()

set(testmain_template_cpp
	"${base_dir}/infrastructure/buildenv-testmain-template.cpp"
)
set(release_or_debug_dir
	"${base_dir}/$<$<CONFIG:Debug>:debug>$<$<CONFIG:Release>:release>$<$<CONFIG:RelWithDebInfo>:release>"
)

file(STRINGS ${base_dir}/modules.txt module_deps REGEX "^[^#]")
foreach(module_dep ${module_deps})

	string(REGEX MATCH "([^	 ]+)[	 ]*(.*)" valid_module_line ${module_dep})
	if(valid_module_line)
		if(DEBUG)
			message(STATUS "found module: ${CMAKE_MATCH_1} -> ${CMAKE_MATCH_2}")
		endif()

		set(module_dir ${CMAKE_MATCH_1})
		set(module_path ${base_dir}/${module_dir})
		string(REPLACE "/" "_" module_name ${CMAKE_MATCH_1})
		string(REPLACE "/" "_" dependencies "${CMAKE_MATCH_2}")

		# We are replacing QDBM's normal build system, and we only want to include
		# the modules that we actually need, to avoid warnings about duplicate
		# definitions, and potential conflicts with Box Backup code in future, so
		# we specify the C files to compile in explicitly.
		if(module_name STREQUAL "qdbm")
			file(GLOB module_files ${module_path}/depot.c ${module_path}/myconf.c)
		else()
			file(GLOB module_files ${module_path}/*.cpp ${module_path}/*.h)
		endif()

		set(module_files ${module_files} ${${module_name}_extra_files})

		string(REGEX REPLACE "^ " "" dependencies "${dependencies}")
		string(REGEX REPLACE " $" "" dependencies "${dependencies}")

		if(module_name MATCHES "^bin_")
			string(REGEX MATCH "^bin_(.*)" valid_exe ${module_name})
			set(bin_name ${CMAKE_MATCH_1})
			if(DEBUG)
				message(STATUS "add executable '${module_name}': '${module_files}'")
			endif()

			add_executable(${module_name} ${module_files})
			# Rename the output executable from bin_bbackupd(.exe) to bbackupd(.exe):
			set_target_properties(${module_name} PROPERTIES
				OUTPUT_NAME "${bin_name}")

			# Use a custom post-build command instead of install(...) to install
			# binaries ready for running tests, because we don't want "make install" to
			# do this too, and absolute-path installations break the CPack generators.
			add_custom_command(TARGET ${module_name} POST_BUILD
				COMMAND ${CMAKE_COMMAND} -E copy
				"$<TARGET_FILE:${module_name}>"
				"${release_or_debug_dir}/${module_dir}/${bin_name}${CMAKE_EXECUTABLE_SUFFIX}"
				VERBATIM)

			# For "make install" and CPack generators:
			install(TARGETS ${module_name} RUNTIME
				CONFIGURATIONS Debug;Release
				DESTINATION "."
				COMPONENT Applications)
		elseif(module_name MATCHES "^test_")
			string(REGEX MATCH "^test_(.*)" valid_test ${module_name})
			set(test_name ${CMAKE_MATCH_1})
			set(bin_name ${module_name})

			if(DEBUG)
				message(STATUS "add test '${module_name}': '${module_files}'")
			endif()

			set(module_files ${module_files} "${testmain_template_cpp}")
			add_executable(${module_name} ${module_files})

			# Use a custom post-build command instead of install(...) to install
			# binaries ready for running tests, because we don't want "make install" to
			# do this too, and absolute-path installations break the CPack generators.
			add_custom_command(TARGET ${module_name} POST_BUILD
				COMMAND ${CMAKE_COMMAND} -E copy
				"$<TARGET_FILE:${module_name}>"
				"${release_or_debug_dir}/${module_dir}/${bin_name}${CMAKE_EXECUTABLE_SUFFIX}"
				VERBATIM)

			if(${APPVEYOR_MODE})
				set(appveyor_runtest_pl_switch -a)
			else()
				set(appveyor_runtest_pl_switch)
			endif()

			if(WIN32)
				set(test_command_internal "$<TARGET_FILE_NAME:${module_name}>")
			else()
				set(test_command_internal "./$<TARGET_FILE_NAME:${module_name}>")
			endif()

			target_compile_definitions(${module_name} PRIVATE
				-DTEST_EXECUTABLE="${test_command_internal}")
			add_test(NAME ${test_name}
				COMMAND ${PERL_EXECUTABLE} ${base_dir}/runtest.pl
				${appveyor_runtest_pl_switch} -c ${test_name}
				$<$<CONFIG:Debug>:DEBUG>$<$<CONFIG:Release>:RELEASE>$<$<CONFIG:RelWithDebInfo>:RELEASE>
				"$<TARGET_FILE:${module_name}>" "${test_command_internal}"
				WORKING_DIRECTORY ${base_dir})

			if(${APPVEYOR_MODE})
				execute_process(COMMAND appveyor AddTest -Name ${test_name}
					-Framework Custom -FileName "")
			endif()

			# It helps with debugging if the test depends on another step which
			# prepares the target directory, and is always out of date.
			add_custom_target(${module_name}-prepare
				COMMAND ${PERL_EXECUTABLE} ${base_dir}/runtest.pl
				-n -c ${test_name}
				$<$<CONFIG:Debug>:DEBUG>$<$<CONFIG:Release>:RELEASE>$<$<CONFIG:RelWithDebInfo>:RELEASE>
				"$<TARGET_FILE:${module_name}>" "${test_command_internal}"
				WORKING_DIRECTORY ${base_dir})
		elseif(module_name MATCHES "^(lib_.*|qdbm)$")
			if(DEBUG)
				message(STATUS "add library '${module_name}': '${module_files}'")
			endif()
			add_library(${module_name} STATIC ${module_files})
		else()
			message(FATAL_ERROR "Unsupported module type: " ${module_name})
		endif()

		target_compile_definitions(${module_name} PRIVATE -DBOX_MODULE="${module_name}")

		if(dependencies)
			string(REGEX REPLACE "[ 	]+" ";" dependency_list "${dependencies}")

			foreach(dependency ${dependency_list})
				if(DEBUG)
					message(STATUS "add dependency to '${module_name}': '${dependency}'")
				endif()
				add_dependencies(${module_name} ${dependency})
				if(dependency MATCHES "^(lib_.*|qdbm)$")
					# message(STATUS "add link library to '${module_name}': '${dependency}'")

=== infrastructure/cmake/windows/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(BoxBackup_Windows)

set(boxbackup_dir ${CMAKE_SOURCE_DIR}/../../..)
set_property(DIRECTORY PROPERTY EP_BASE .)
set(install_dir ${CMAKE_BINARY_DIR}/install)

# Automate the process of downloading, building and "installing" dependencies on Windows,
# as used by AppVeyor.

# Version of zlib to download, build, and compile Box Backup against:
set(ZLIB_VERSION    1.2.11)
# Hash of zlib-${ZLIB_VERSION}.tar.gz, to be verified after download:
set(ZLIB_HASH SHA256=c3e5e9fdd5004dcb542feda5ee4f0ff0744628baf8ed2dd5d66f8ca1197cb1a1)

# Version of OpenSSL to download, build, and compile Box Backup against:
set(OPENSSL_VERSION 1.1.0g)
# Hash of openssl-${OPENSSL_VERSION}.tar.gz, to be verified after download:
set(OPENSSL_HASH SHA256=de4d501267da39310905cb6dc8c6121f7a2cad45a7707f76df828fe1b85073af)

# Version of PCRE to download, build, and compile Box Backup against:
set(PCRE_VERSION    8.39)
# Hash of pcre-${PCRE_VERSION}.tar.gz, to be verified after download:
set(PCRE_HASH SHA256=ccdf7e788769838f8285b3ee672ed573358202305ee361cfec7a4a4fb005bbc7)

# Version of Boost to download, unpack, and compile Box Backup against:
set(BOOST_VERSION    1.62.0)
# Hash of the Boost download file, to be verified after download:
set(BOOST_HASH SHA1=5fd97433c3f859d8cbab1eaed4156d3068ae3648)

include(ExternalProject)

ExternalProject_Add(zlib
	URL "http://zlib.net/zlib-${ZLIB_VERSION}.tar.gz"
	URL_HASH ${ZLIB_HASH}
	DOWNLOAD_NO_PROGRESS 1
	CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${install_dir} ${SUB_CMAKE_EXTRA_ARGS}
	# We need to build both versions, debug and release, because cmake requires both to be
	# present to generate its multi-configuration project files for Visual Studio/MSBuild.
	INSTALL_COMMAND ${CMAKE_COMMAND} --build <BINARY_DIR> --target install --config Debug
	COMMAND         ${CMAKE_COMMAND} --build <BINARY_DIR> --target install --config Release
	STEP_TARGETS configure install
)

if(WIN32)
	ExternalProject_Add(openssl
		DEPENDS zlib
		URL "https://www.openssl.org/source/openssl-${OPENSSL_VERSION}.tar.gz"
		URL_HASH ${OPENSSL_HASH}
		DOWNLOAD_NO_PROGRESS 1
		CONFIGURE_COMMAND perl Configure debug-VC-WIN32 no-asm no-shared
			--prefix=${install_dir}
			--openssldir=etc
		# Run tests before install, but don't make the main target depend on them, so that
		# we don't have to run them whenever we build manually on Windows.
		TEST_BEFORE_INSTALL 1
		TEST_EXCLUDE_FROM_MAIN 1
		# You would expect us to use nt.mak to compile a static library here, but mk1mf.pl uses the /MT[d]
		# CRT in that case, which is incompatible with our dynamic runtime, /MD[d]. It seems that the libs
		# built by ntdll.mak, which are compiled with /MD[d], are full libraries and not import libs,
		# so we can link statically against them and still get a dynamic runtime.
		BUILD_IN_SOURCE 1
		BUILD_COMMAND   nmake /s
		TEST_COMMAND    nmake /s test
		INSTALL_COMMAND nmake /s install
	)
elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	ExternalProject_Add(openssl
		DEPENDS zlib
		URL "https://www.openssl.org/source/openssl-${OPENSSL_VERSION}.tar.gz"
		URL_HASH ${OPENSSL_HASH}
		DOWNLOAD_NO_PROGRESS 1
		CONFIGURE_COMMAND perl Configure darwin64-x86_64-cc --prefix=${install_dir}
		BUILD_IN_SOURCE 1
	)
else()
	ExternalProject_Add(openssl
		DEPENDS zlib
		URL "https://www.openssl.org/source/openssl-${OPENSSL_VERSION}.tar.gz"
		URL_HASH ${OPENSSL_HASH}
		DOWNLOAD_NO_PROGRESS 1
		CONFIGURE_COMMAND ./config --prefix=${install_dir}
		BUILD_IN_SOURCE 1
	)

endif()

ExternalProject_Add(pcre
	# Temporarily use SVN repo until the PCRE_STATIC issue in 8.40 is fixed:
	# https://vcs.pcre.org/pcre?view=revision&revision=1677
	SVN_REPOSITORY svn://vcs.exim.org/pcre/code/trunk
	SVN_REVISION -r 1677
	DOWNLOAD_NO_PROGRESS 1
	CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${install_dir} ${SUB_CMAKE_EXTRA_ARGS}
	-DPCRE_SUPPORT_LIBREADLINE=OFF
	-DPCRE_SUPPORT_LIBBZ2=OFF
	# We need to build both versions, debug and release, because cmake requires both to be
	# present to generate its multi-configuration project files for Visual Studio/MSBuild.
	INSTALL_COMMAND ${CMAKE_COMMAND} --build <BINARY_DIR> --target install --config Debug
	COMMAND         ${CMAKE_COMMAND} --build <BINARY_DIR> --target install --config Release
)

string(REPLACE "." "_" BOOST_VERSION_UNDERSCORES ${BOOST_VERSION})
ExternalProject_Add(boost
	URL "http://downloads.sourceforge.net/project/boost/boost/${BOOST_VERSION}/boost_${BOOST_VERSION_UNDERSCORES}.tar.bz2"
	URL_HASH ${BOOST_HASH}
	# DOWNLOAD_NO_PROGRESS 1
	# Disable automatic updating (untarring) as it's slow and not necessary
	UPDATE_DISCONNECTED 1
	CONFIGURE_COMMAND ${CMAKE_COMMAND} -E echo "No configure step needed"
	BUILD_COMMAND ${CMAKE_COMMAND} -E echo "No build step needed"
	INSTALL_COMMAND ${CMAKE_COMMAND} -E echo "No install step needed"
)

if(BOXBACKUP_VERSION)
	list(APPEND boxbackup_cmake_args "-DBOXBACKUP_VERSION=${BOXBACKUP_VERSION}")
endif()
string(REPLACE ";" " " boxbackup_cmake_args "${boxbackup_cmake_args}")

ExternalProject_Add(boxbackup
	DEPENDS zlib openssl pcre boost
	SOURCE_DIR ${boxbackup_dir}/infrastructure/cmake
	CMAKE_ARGS
		-DZLIB_ROOT=${install_dir}
		-DOPENSSL_ROOT_DIR=${install_dir}
		-DPCRE_ROOT=${install_dir}
		-DBOOST_ROOT=${CMAKE_BINARY_DIR}/Source/boost
		-DBOX_SUPPORT_READLINE=OFF
		-DCMAKE_INSTALL_PREFIX=${install_dir}
		-DAPPVEYOR_MODE=1
		-DDEBUG=${DEBUG}
		${boxbackup_cmake_args}
		${SUB_CMAKE_EXTRA_ARGS}
	INSTALL_COMMAND ${CMAKE_COMMAND} -E echo "No install step needed"
	STEP_TARGETS configure build
)

=== debian/changelog ===
boxbackup (0.13~~git20180313.g16a11e86-1ubuntu1) cosmic; urgency=medium

  * Ignore test suite results, always fails, not run on most arches anyway.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 01 Oct 2018 13:38:42 +0100

boxbackup (0.13~~git20180313.g16a11e86-1) unstable; urgency=medium

  * New upstream pre-release (requested by upstream)
  * Fixes test failures on i386 (closes: #890997)

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 14 Mar 2018 08:19:09 -0400

boxbackup (0.13~~git20180303.g6178fd34-1) unstable; urgency=medium

  * New upstream pre-release (requested by upstream)
  * Compile against libssl 1.1 (again) (Closes: #870775)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 03 Mar 2018 14:08:09 -0500

boxbackup (0.13~~git20180102.g6d7e9562-2) unstable; urgency=medium

  * Revert to libssl 1.1 on upstream's request. This will be reverted as
    soon as the issues caused by openssl 1.1 are addressed. Until then,
    this Reopens: #870775.

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 28 Feb 2018 08:31:56 -0500

boxbackup (0.13~~git20180102.g6d7e9562-1) unstable; urgency=medium

  [ Andreas Henriksson ]
  * QA upload.
  * debian/boxbackup-server.config: Fix quoting of variables primarily
    fixing the logic that handles when tune2fs is not available.
  * Have boxbackup-server package Recommend e2fsprogs since the
    package configuration (optionally) uses tune2fs in some cases.
    (Closes: #887274)

  [ Reinhard Tartler ]
  * New upstream pre-release (requested by upstream)
  * Migrate to libssl 1.1 (Closes: #870775)

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 20 Feb 2018 21:53:32 -0500

boxbackup (0.12~gitcf52058f-3) unstable; urgency=medium

  * QA upload.
  * Run the testsuite on amd64 and i386 only (Closes: #866372)

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 30 Jun 2017 15:01:19 -0400

boxbackup (0.12~gitcf52058f-2) unstable; urgency=medium

  * Fix FTBFS on signed arch architectures (Closes: #865092)

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 20 Jun 2017 22:23:07 -0400

boxbackup (0.12~gitcf52058f-1) unstable; urgency=medium

  * QA upload.
  * Honor test failures during build (Closes: #744266)
  * New upstream release: 0.12 (Closes: #744911)
    - has openssl 1.1 support (Closes: #851092)
  * Update the notifyadmin.sh script (Closes: #483928)
  * Add systemd unit files.

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 17 Jun 2017 17:54:09 -0400

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,18 @@
 Source: boxbackup
 Section: utils
 Priority: optional
-Maintainer: Debian QA Group <packages@qa.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends:
  autoconf,
  automake,
- autotools-dev,
- debhelper (>> 7.0.0),
+ debhelper (>> 10),
  docbook-utils,
  docbook-xml,
  docbook-xsl,
  libdb-dev (>= 4.7),
  libedit-dev,
- libssl1.0-dev,
+ libssl-dev,
  libtest-lwp-useragent-perl,
  xsltproc,
  zlib1g-dev
@@ -27,11 +27,13 @@
  adduser,
  debconf | debconf-2.0,
  gawk,
+ lsb-base (>= 3.0-6),
  openssl,
  perl,
  ucf,
  ${misc:Depends},
  ${shlibs:Depends}
+Recommends: e2fsprogs
 Description: server for the BoxBackup remote backup system
  BoxBackup is an automatic on-line backup system.
  The server waits for connections from remote clients,
@@ -43,6 +45,7 @@
 Architecture: any
 Depends:
  debconf | debconf-2.0,
+ lsb-base (>= 3.0-6),
  openssl,
  perl,
  ucf,

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,8 @@
 
 # Uncomment this to turn on verbose mode. 
 #export DH_VERBOSE=1
+
+include /usr/share/dpkg/pkg-info.mk
 
 # These are used for cross-compiling and for saving the configure script
 # from having to guess our platform (since we know it already)
@@ -20,8 +22,7 @@
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
-	dh_autotools-dev_updateconfig
-	echo "0.11rc8+`cat .svnrevision`" > VERSION.txt
+	echo "$(DEB_VERSION_UPSTREAM_REVISION)" > VERSION.txt
 	echo "boxbackup" >> VERSION.txt
 	sh -x ./bootstrap
 	./configure $(DEB_EXTRA_CONFIG_FLAGS) LDFLAGS="-Wl,--as-needed"
@@ -30,8 +31,12 @@
 build-stamp: configure-stamp
 	dh_testdir
 	$(MAKE) V=1
+# the testsuite is only really maintained on i386 and amd64
+# and fails there too, ignore.
+ifneq (,$(filter $(DEB_HOST_ARCH),i386 amd64))
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
 	-./runtest.pl ALL
+endif
 endif
 	touch build-stamp
 
@@ -59,7 +64,6 @@
 	echo "boxbackup" >> VERSION.txt
 	[ ! -f Makefile ] || make clean
 	sh debian/clean.sh
-	dh_autotools-dev_restoreconfig
 	dh_clean config.log config.status 
 
 install: DH_OPTIONS=

## boxbackup 0.13~~git20190527.g039c4a1

=== debian/changelog ===
boxbackup (0.13~~git20190527.g039c4a1-4ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Ignore test suite results, always fails, not run on most arches anyway.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Feb 2020 16:42:07 +0100

boxbackup (0.13~~git20190527.g039c4a1-4) unstable; urgency=medium

  * QA upload.
  * Really upload to unstable.
  * Verified that builds with tests enabled (Closes: #943517)
  * Bump Standards-version (no changes needed)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 15 Feb 2020 14:07:15 -0500

boxbackup (0.13~~git20190527.g039c4a1-2) experimental; urgency=medium

  * QA upload.
  * Upload to unstable.

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 20 Jul 2019 00:50:07 -0400

boxbackup (0.13~~git20190527.g039c4a1-1) experimental; urgency=medium

  * QA upload.
  * Update to new upstream version 0.13~~git20190527.g039c4a1 Requested by
    upstream, now uses 2048bit keys by default. Keys generated with
    earlier versions are considered "weak" and generate a warning for now.
    (Closes: #907135)

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 27 May 2019 18:40:14 -0400

boxbackup (0.13~~git20180819.g2f5b556-1) unstable; urgency=medium

  * New upstream pre-release
  * debian/watch: Track commits on master from github.com

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 10 Mar 2019 14:11:33 -0400

boxbackup (0.13~~git20180313.g16a11e86-2ubuntu1) eoan; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Ignore test suite results, always fails, not run on most arches anyway.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 28 Jun 2019 18:56:37 +0200

boxbackup (0.13~~git20180313.g16a11e86-2) unstable; urgency=medium

  * QA upload.
  * debian/control: Point Vcs headers to salsa
  * Bugfix compile against openssl1.1 (Closes: #907135).

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 07 Jun 2019 05:55:39 -0400

## boxbackup 0.13~~git20200326.g8e8b63c

=== docs/Makefile ===
# Process DocBook to HTML

# This makefile is a bit obfuscated so that it works correctly on both
# BSD and GNU make. Some parts apply to one version of make and not the
# other; these are marked by comments.

# The "all" target shouldn't be up here, but the trickery below defines
# what looks like a rule to GNU make, and so we need to define the actual
# default target before it.

all: docs

DBPROC_COMMAND = xsltproc
MKDIR_COMMAND  = mkdir
CP_COMMAND     = cp
PERL_COMMAND   = perl
RM_COMMAND     = rm -f
TAR_COMMAND    = tar
GZIP_COMMAND   = gzip -f
GENERATE_SCRIPT = tools/generate_except_xml.pl

DBPROC   = $(DBPROC_COMMAND)
MKDIR    = $(MKDIR_COMMAND)
CP       = $(CP_COMMAND)
GENERATE = $(PERL_COMMAND) $(GENERATE_SCRIPT)
RM_QUIET = $(RM_COMMAND)
TAR      = $(TAR_COMMAND)
GZIP     = $(GZIP_COMMAND)
PROGRESS = @ true

# use a GNU make "define" command, that looks like a harmless dummy rule
# to BSD make, to hide parts of the Makefile from GNU make.
define IGNORED_BY_GNU_MAKE:
.if 0
endef

  # seen by GNU make, not by BSD make
  ifeq ($(V),)
    DBPROC   = @ echo "  [XLSTPROC]" $^ && $(DBPROC_COMMAND) 2>/dev/null
    GENERATE = @ echo "  [GENERATE]" $@ && $(PERL_COMMAND) $(GENERATE_SCRIPT)
    TAR      = @ echo "  [TAR]     " $@ && $(TAR_COMMAND)
    GZIP     = @ echo "  [GZIP]    " $< && $(GZIP_COMMAND)
    RM_QUIET = @ $(RM_COMMAND)
    PROGRESS = @ echo
  endif  

define IGNORED_BY_GNU_MAKE:
.endif

.ifndef V
  # seen by BSD make, not by GNU make
  DBPROC   = @ echo "  [XSLTPROC]" $(.ALLSRC) && $(DBPROC_COMMAND) 2>/dev/null
  GENERATE = @ echo "  [GENERATE]" $(.TARGET) && $(PERL_COMMAND) $(GENERATE_SCRIPT)
  TAR      = @ echo "  [TAR]     " $(.TARGET) && $(TAR_COMMAND)
  GZIP     = @ echo "  [GZIP]    " $(.TARGET:.gz=) && $(GZIP_COMMAND)
  RM_QUIET = @ $(RM_COMMAND)
  PROGRESS = @ echo
.endif

# neither .endif nor endef can be followed by a colon; each creates
# warnings or errors in one or other version of make. we need some
# magic to make them both work. Luckily, .endfor ignores the colon.

.for DUMMY in $(NO_SUCH_VARIABLE)
endef
.endfor :

PROGRESS_RM = $(PROGRESS) "  [RM]      "

DOCBOOK_DIR = docbook
HTML_DIR = htmlguide
MAN_DIR = man

BOOKXSL = $(DOCBOOK_DIR)/bb-book.xsl
NOCHUNKBOOKXSL = $(DOCBOOK_DIR)/bb-nochunk-book.xsl
MANXSL = $(DOCBOOK_DIR)/bb-man.xsl

VPATH = $(DOCBOOK_DIR)
.SUFFIXES: .html .xml .gz .1 .5 .8

docs: instguide adminguide manpages
	@mkdir -p $(HTML_DIR)/images
	@cp $(DOCBOOK_DIR)/html/images/*.png $(HTML_DIR)/images/.
	@cp $(DOCBOOK_DIR)/html/*.css $(HTML_DIR)/.
	@cp $(DOCBOOK_DIR)/html/*.ico $(HTML_DIR)/.

adminguide: $(DOCBOOK_DIR)/ExceptionCodes.xml $(HTML_DIR)/adminguide/index.html 

# $^ gives all sources on GNU make, and nothing on BSD make
# $> gives all sources on BSD make, and nothing on GNU make
$(HTML_DIR)/adminguide/index.html: $(BOOKXSL) $(DOCBOOK_DIR)/adminguide.xml
	$(DBPROC) -o $(HTML_DIR)/adminguide/ $^ $>

instguide: $(HTML_DIR)/instguide/index.html 

$(HTML_DIR)/instguide/index.html: $(BOOKXSL) $(DOCBOOK_DIR)/instguide.xml
	$(DBPROC) -o $(HTML_DIR)/instguide/ $^ $>

# On BSD make, $> contains all sources and $^ is empty 
# On GNU make, $^ contains all sources and $> is empty
$(DOCBOOK_DIR)/ExceptionCodes.xml: ../ExceptionCodes.txt
	$(GENERATE) $> $^ $@

manpages: man-dirs man-nroff man-html

man-dirs: man/.there $(HTML_DIR)/man-html/.there

$(HTML_DIR)/man-html/.there:
	mkdir -p $(HTML_DIR)/man-html
	touch $(HTML_DIR)/man-html/.there

man/.there:
	mkdir -p man
	touch man/.there

NROFF_PAGES = bbackupd.8 bbackupd-config.8 bbackupctl.8 bbackupquery.8 \
	bbstored.8 bbstored-config.8 bbstoreaccounts.8 bbstored-certs.8 \
	raidfile-config.8 \
	bbackupd.conf.5 bbstored.conf.5 raidfile.conf.5

NROFF_FILES = $(NROFF_PAGES:%=$(MAN_DIR)/%.gz)

man-nroff: $(NROFF_FILES)

HTML_FILES_1 = $(NROFF_PAGES:%.5=%.html)
HTML_FILES_2 = $(HTML_FILES_1:%.8=%.html)
HTML_FILES   = $(HTML_FILES_2:%=$(HTML_DIR)/man-html/%)

man-html: $(HTML_FILES)

# $^ gives all sources on GNU make, and nothing on BSD make

# GNU make
$(HTML_DIR)/man-html/%.html: $(NOCHUNKBOOKXSL) $(DOCBOOK_DIR)/%.xml
	$(DBPROC) -o $@ $^

# GNU make
$(MAN_DIR)/%.8: $(MANXSL) $(DOCBOOK_DIR)/%.xml
	$(DBPROC) -o $@ $^

# GNU make
$(MAN_DIR)/%.8.gz: $(MAN_DIR)/%.8
	$(GZIP) $<

# GNU make
$(MAN_DIR)/%.5: $(MANXSL) $(DOCBOOK_DIR)/%.xml $(MANXSL)
	$(DBPROC) -o $@ $^

# GNU make
$(MAN_DIR)/%.5.gz: $(MAN_DIR)/%.5
	$(GZIP) $<

# BSD make: the final colon (:) is required to make the .for and .endfor
# lines valid in GNU make. It creates (different) dummy rules in GNU and
# BSD make. Both dummy rules are harmless.

.for MAN_PAGE in $(NROFF_PAGES) :
$(MAN_DIR)/$(MAN_PAGE).gz: $(MANXSL) $(DOCBOOK_DIR)/$(MAN_PAGE:R).xml
	$(DBPROC) -o $(.TARGET:.gz=) $(.ALLSRC)
	$(GZIP) $(.TARGET:.gz=)

$(HTML_DIR)/man-html/$(MAN_PAGE:R).html: $(NOCHUNKBOOKXSL) \
$(DOCBOOK_DIR)/$(MAN_PAGE:R).xml
	$(DBPROC) -o $(.TARGET) $(.ALLSRC)
.endfor :

dockit: clean docs documentation-kit-0.10.tar.gz

documentation-kit-0.10.tar.gz:
	$(TAR) zcf documentation-kit-0.10.tar.gz $(HTML_DIR)/

clean:
	$(PROGRESS_RM) "$(HTML_DIR)/man-html/*.html"
	$(RM_QUIET) $(HTML_FILES)

	$(PROGRESS_RM) "$(MAN_DIR)/*.[58].gz"
	$(RM_QUIET) $(NROFF_FILES)

	$(PROGRESS_RM) "$(DOCBOOK_DIR)/ExceptionCodes.xml"
	$(RM_QUIET) $(DOCBOOK_DIR)/ExceptionCodes.xml
	
	$(PROGRESS_RM) "documentation-kit-0.10.tar.gz"
	$(RM_QUIET) documentation-kit-0.10.tar.gz

=== infrastructure/cmake/CMakeLists.txt ===
--- 
+++ 
@@ -71,13 +71,6 @@
 	endif()
 endfunction()
 
-foreach(file_to_configure ${files_to_configure})
-	configure_file("${base_dir}/${file_to_configure}.in" "${base_dir}/${file_to_configure}.out" @ONLY)
-	replace_file_if_different(
-		"${base_dir}/${file_to_configure}"
-		"${base_dir}/${file_to_configure}.out")
-endforeach()
-
 # If BOXBACKUP_VERSION is defined when running CMake (as the AppVeyor config does), use it
 # as-is, since it contains the full version number, branch, and platform (Win32/Win64):
 if(BOXBACKUP_VERSION)
@@ -325,3 +318,10 @@
 				add_dependencies(${module_name} ${dependency})
 				if(dependency MATCHES "^(lib_.*|qdbm)$")
 					# message(STATUS "add link library to '${module_name}': '${dependency}'")
+					target_link_libraries(${module_name} PUBLIC ${dependency})
+				endif()
+
+				# We can't make a binary depend on another binary, so we need to
+				# add the dependency's directory directly to our include path.
+				if(dependency MATCHES "^bin_")
+					get_property(dep_include_dirs

=== debian/changelog ===
boxbackup (0.13~~git20200326.g8e8b63c-1ubuntu2) jammy; urgency=medium

  * Fix the build against C++17-enabled compilers (Closes: #984002)

 -- Simon Chopin <simon.chopin@canonical.com>  Thu, 25 Nov 2021 11:45:22 +0100

boxbackup (0.13~~git20200326.g8e8b63c-1ubuntu1) groovy; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Ignore test suite results, always fails, not run on most arches anyway.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 11 May 2020 16:11:17 +0200

boxbackup (0.13~~git20200326.g8e8b63c-1) unstable; urgency=medium

  * QA upload.
  * New upstream version 0.13~~git20200326.g8e8b63c
    - disables leak detection

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 10 May 2020 18:55:55 -0400

=== debian/control ===
--- 
+++ 
@@ -16,10 +16,10 @@
  libtest-lwp-useragent-perl,
  xsltproc,
  zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.5.0
 Homepage: http://boxbackup.org
-Vcs-Git: git://anonscm.debian.org/collab-maint/boxbackup.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/boxbackup.git
+Vcs-Git: https://salsa.debian.org/debian/boxbackup.git
+Vcs-Browser: https://salsa.debian.org/debian/boxbackup
 
 Package: boxbackup-server
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -32,7 +32,6 @@
 	dh_testdir
 	$(MAKE) V=1
 # the testsuite is only really maintained on i386 and amd64
-# and fails there too, ignore.
 ifneq (,$(filter $(DEB_HOST_ARCH),i386 amd64))
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
 	-./runtest.pl ALL

=== debian/watch ===
version=3
# upstream does not plan to make specific releases anymore, cf
# http://lists.boxbackup.org/pipermail/boxbackup/2019-January/006690.html
opts="mode=git, gpgmode=none, pretty=0.13~~git%cd.g%h" \
  https://github.com/boxbackup/boxbackup HEAD debian uupdate
